=== debian/changelog ===
rust-cargo-c (0.10.11-1) unstable; urgency=medium

  * Team upload.
  * Package cargo-c 0.10.11+cargo-0.86.0 from crates.io using debcargo 2.7.7
  * Downgrade cbindgen to 0.27
  * Downgrade implib to 0.3.3

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 07 Mar 2025 09:45:59 +0100
